/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import { z } from "zod";

export const PrefixSchema = z.object({
    name: z.string().startsWith("PREFIX_"),
    colorCode: z.string().startsWith("§"),
    chatPrefix: z.string(),
});

export type Prefix = z.infer<typeof PrefixSchema>;

export const PermsSchema = z.object({
    perms: z.array(z.string()),
    prefixes: z.record(PrefixSchema),
});

export type Perms = z.infer<typeof PermsSchema>;

export const UserPermsSchema = z.object({
    prefix: PrefixSchema,
    perms: z.array(z.string()),
});

export type UserPerms = z.infer<typeof UserPermsSchema>;
